﻿// C++/WinRT v1.0.180227.3

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.

#pragma once
#include "winrt/impl/Windows.Foundation.0.h"
#include "winrt/impl/Windows.Security.Credentials.0.h"
#include "winrt/impl/Windows.UI.0.h"
#include "winrt/impl/Windows.UI.Shell.0.h"
#include "winrt/impl/Windows.ApplicationModel.UserActivities.0.h"

WINRT_EXPORT namespace winrt::Windows::ApplicationModel::UserActivities {

struct WINRT_EBO IUserActivity :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivity>
{
    IUserActivity(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivity2 :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivity2>
{
    IUserActivity2(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityAttribution :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityAttribution>
{
    IUserActivityAttribution(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityAttributionFactory :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityAttributionFactory>
{
    IUserActivityAttributionFactory(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityChannel :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityChannel>
{
    IUserActivityChannel(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityChannel2 :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityChannel2>
{
    IUserActivityChannel2(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityChannelStatics :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityChannelStatics>
{
    IUserActivityChannelStatics(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityChannelStatics2 :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityChannelStatics2>,
    impl::require<IUserActivityChannelStatics2, Windows::ApplicationModel::UserActivities::IUserActivityChannelStatics>
{
    IUserActivityChannelStatics2(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityContentInfo :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityContentInfo>
{
    IUserActivityContentInfo(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityContentInfoStatics :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityContentInfoStatics>
{
    IUserActivityContentInfoStatics(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityFactory :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityFactory>
{
    IUserActivityFactory(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityRequest :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityRequest>
{
    IUserActivityRequest(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityRequestManager :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityRequestManager>
{
    IUserActivityRequestManager(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityRequestManagerStatics :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityRequestManagerStatics>
{
    IUserActivityRequestManagerStatics(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityRequestedEventArgs :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityRequestedEventArgs>
{
    IUserActivityRequestedEventArgs(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivitySession :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivitySession>,
    impl::require<IUserActivitySession, Windows::Foundation::IClosable>
{
    IUserActivitySession(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivitySessionHistoryItem :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivitySessionHistoryItem>
{
    IUserActivitySessionHistoryItem(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityStatics :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityStatics>
{
    IUserActivityStatics(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityVisualElements :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityVisualElements>
{
    IUserActivityVisualElements(std::nullptr_t = nullptr) noexcept {}
};

struct WINRT_EBO IUserActivityVisualElements2 :
    Windows::Foundation::IInspectable,
    impl::consume_t<IUserActivityVisualElements2>
{
    IUserActivityVisualElements2(std::nullptr_t = nullptr) noexcept {}
};

}
